/**
 * Created by rowild13 on 20.02.14.
 */

// FONTSIZE
// Stylesheet setzen inkl. Cookie

function setInitialFontsize(size){
    this.body = document.getElementsByTagName('body')[0].style;
    this.body.fontSize = size + "%";
    createFontsizeCookie("ZID_fontSize",size,365);
}

function setFontsize(size) {
    var curSize = 100;
    this.body = document.getElementsByTagName('body')[0].style;

    var bodySize = parseInt(this.body.fontSize.substring(0,3));

    if(isNaN(bodySize)) {
        bodySize = 100;
    }
    curSize = bodySize + size;
    if(curSize > 160){
        curSize = 160;
        document.getElementById("fontPlus").src="/fileadmin/templates/uni_templates_2008/bilder/font_plus_disabled.gif";
    } else if (curSize < 100){
        curSize = 100;
        document.getElementById("fontMinus").src="/fileadmin/templates/uni_templates_2008/bilder/font_minus_disabled.gif";
    } else {
        document.getElementById("fontPlus").src="/fileadmin/templates/uni_templates_2008/bilder/font_plus.gif";
        document.getElementById("fontMinus").src="/fileadmin/templates/uni_templates_2008/bilder/font_minus.gif";
    }
    this.body.fontSize = curSize + "%";
    createFontsizeCookie("ZID_fontSize",curSize,365);
}

function getFontsize() {
    this.body = document.getElementsByTagName('body')[0].style;
    return this.body.fontSize;
}

function createFontsizeCookie(name,value,days) {
    if (days) {
        var date = new Date();
        date.setTime(date.getTime()+(days*24*60*60*1000));
        var expires = "; expires="+date.toGMTString();
    } else {
        expires = "";
    }
    document.cookie = name+"="+value+expires+"; path=/";
}

function readFontsizeCookie(name) {
    var nameEQ = name + "=";
    var ca = document.cookie.split(';');

    for(var i=0;i < ca.length;i++) {
        var c = ca[i];
        while (c.charAt(0)==' ') {
            c = c.substring(1,c.length);
            if (c.indexOf(nameEQ) == 0){
                var kuki = c.substring(nameEQ.length,c.length);
                return parseInt(kuki);
            }
        }

    }

    // Fallback: standard value 100
    return 100;
}


// KONTRAST
// Stylesheet setzen inkl. Cookie

function setActiveStyleSheet(title) {


    var i, a, main;

    for(i=0; (a = document.getElementsByTagName("link")[i]); i++) {
        if(a.getAttribute("rel").indexOf("style") != -1 && a.getAttribute("title")) {
            a.disabled = true;
            if(a.getAttribute("title") == title) {
                a.disabled = false;
            }
        }
    }
    //standard stylesheet gibt keinen Titel zurück, sollte im template am Button gesetzt werden,
    //da Kontrast, im Gegensatz, den Titel 'Kontrast' liefert
    if(title == "" || title == "null" || title == null) {
        title = "standard";
    }
    createKontrastCookie("ZIDweb_style", title, 365);
}

function getActiveStyleSheet() {
    var i, a;
    for(i=0; (a = document.getElementsByTagName("link")[i]); i++) {
        if(a.getAttribute("rel").indexOf("style") != -1 && a.getAttribute("title") && !a.disabled) return a.getAttribute("title");
    }
    return null;
}

function getPreferredStyleSheet() {
    var i, a;
    for(i=0; (a = document.getElementsByTagName("link")[i]); i++) {
        if(a.getAttribute("rel").indexOf("style") != -1 && a.getAttribute("rel").indexOf("alt") == -1 && a.getAttribute("title") ) {
            return a.getAttribute("title");
        }
    }
    return null;
}

function createKontrastCookie(name,value,days) {
    if (days) {
        var date = new Date();
        date.setTime(date.getTime()+(days*24*60*60*1000));
        var expires = "; expires="+date.toGMTString();
    } else {
        expires = "";
    }
    document.cookie = name+"="+value+expires+"; path=/";
}

function readKontrastCookie(name) {

    var re = new RegExp('[; ]'+name+'=([^\\s;]*)');
    var sMatch = (' '+document.cookie).match(re);
    if (name && sMatch) return unescape(sMatch[1]);
    
    // Fallback: standard value
    return "standard";
}



function init(){

    // Kontrast Cookie
    var cookieKontrast = readKontrastCookie("ZIDweb_style");
    //console.log("cookie kontrast: " + cookieKontrast);
    titleKontrast = (cookieKontrast != "null" && cookieKontrast != null && cookieKontrast != "") ? cookieKontrast : "standard";

    setActiveStyleSheet(titleKontrast);
    createKontrastCookie("ZIDweb_style", titleKontrast, 365);

    // Fonsize Cookie
    var cookieFontsize = readFontsizeCookie("ZID_fontSize"),
    size = (cookieFontsize != "null" && cookieFontsize != null && cookieFontsize !="NaN" && cookieFontsize != "" && !isNaN(cookieFontsize)) ? cookieFontsize : 100;


    setInitialFontsize(size);

//    cookie is set in setFontsize function; remove here!
    createFontsizeCookie("ZID_fontSize", size, 365);
}


init();
